# FIXME Follow https://fedoraproject.org/wiki/Packaging:Python
%define is_el7 %(test 0%{?centos} -eq 07 || test 0%{?rhel} -eq 07 && echo 1 || echo 0)

Name:           imgbased
Version:        0.9.52
Release:        %{?_release}%{?!_release:0.1}%{?dist}
Summary:        Tools to work with an image based rootfs

License:        GPLv2+
URL:            https://www.github.com/fabiand/imgbased
Source0:        http://resources.ovirt.org/pub/src/%{name}/%{name}-%{version}.tar.xz

BuildArch:      noarch

# Skips check since rhel default repos lack pep8, pyflakes and python-nose
%if ! 0%{?rhel}
%{!?with_check:%global with_check 1}
%else
%{!?with_check:%global with_check 0}
%endif

BuildRequires:       make
BuildRequires:       automake autoconf
BuildRequires:       rpm-build
BuildRequires:       git
BuildRequires:       asciidoc
BuildRequires:       systemd-units

BuildRequires:       python-devel python-six

%if 0%{?with_check}
BuildRequires:       python-pep8 pyflakes python-nose
%endif

BuildRequires:       rpm-python

%if 0%{?is_el7}
BuildRequires:       python-six
%else
Recommends:          systemd-python3
BuildRequires:       python3-six
BuildRequires:       python3-devel
%endif

Requires:            lvm2
Requires:            util-linux
Requires:            augeas
Requires:            rsync
Requires:            yum


%description
This tool enforces a special usage pattern for LVM.
Basically this is about having read-only bases and writable
layers atop.


%prep
%setup -q


%build
%configure
make %{?_smp_mflags}


%install
%if 0%{?fedora}
install -Dm 0644 src/plugin-dnf/imgbased-persist.conf \
                 %{buildroot}/%{_sysconfdir}/dnf/pluginconf.d/imgbased-persist.conf
install -Dm 0644 src/plugin-dnf/imgbased-persist.py \
                 %{buildroot}/%{python3_sitelib}/dnf-plugins/imgbased-persist.py
%else
install -Dm 0644 src/plugin-yum/imgbased-persist.py \
                 %{buildroot}/%{_prefix}/lib/yum-plugins/imgbased-persist.py
install -Dm 0644 src/plugin-yum/imgbased-persist.conf \
                 %{buildroot}/%{_sysconfdir}/yum/pluginconf.d/imgbased-persist.conf
%endif
install -Dm 0644 data/imgbase-clean-grub.service %{buildroot}%{_unitdir}/imgbase-clean-grub.service
install -Dm 0644 data/imgbase-copy-bootfiles.service %{buildroot}%{_unitdir}/imgbase-copy-bootfiles.service
install -Dm 0644 data/imgbase-generate-iqn.service %{buildroot}%{_unitdir}/imgbase-generate-iqn.service
install -Dm 0644 data/imgbase-config-vdsm.service %{buildroot}%{_unitdir}/imgbase-config-vdsm.service
install -Dm 0755 scripts/grub/09_node %{buildroot}%{_sysconfdir}/grub.d/09_node
%make_install


%files
%doc README.md
%license LICENSE
%{_sbindir}/imgbase
%{_sbindir}/imgbase-copy-bootfiles
%{_datadir}/%{name}/hooks.d/
%{python_sitelib}/%{name}/
%{_mandir}/man8/imgbase.8*
%{_mandir}/man8/imgbase-copy-bootfiles.8*
/%{_docdir}/%{name}/*.asc
%{_unitdir}/imgbase-*.service
%{_sysconfdir}/grub.d/09_node
%if 0%{?fedora}
%{_sysconfdir}/dnf/pluginconf.d/imgbased-persist.conf
%{python3_sitelib}/dnf-plugins/imgbased-persist.py*
%{python3_sitelib}/dnf-plugins/__pycache__/imgbased*
%else
%{_sysconfdir}/yum/pluginconf.d/imgbased-persist.conf
%{_prefix}/lib/yum-plugins/imgbased-persist.py*
%endif

%changelog
* Mon Jan 15 2018 Ryan Barry <rbarry@redhat.com> - 0.9.52-0
- Cleanup boot files when layers are removed

* Thu Nov 16 2017 Ryan Barry <rbarry@redhat.com> - 0.9.51-0
- Don't remediate ifcfg files

* Wed Nov 01 2017 Ryan Barry <rbarry@redhat.com> - 0.9.50-0
- Only resync files if the path exists

* Wed Nov 01 2017 Ryan Barry <rbarry@redhat.com> - 0.9.49-0
- Resync files for satellite on update

* Tue Sep 26 2017 Ryan Barry <rbarry@redhat.com> - 0.9.48-0
- Try to block `kill` from imgbase-copy-bootfiles

* Wed Aug 16 2017 Ryan Barry <rbarry@redhat.com> - 0.9.47-0
- Reconcile setfiles from git

* Wed Aug 16 2017 Ryan Barry <rbarry@redhat.com> - 0.9.46-0
- idmap should mark as drifted if new uids/gids are added

* Wed Aug 16 2017 Ryan Barry <rbarry@redhat.com> - 0.9.45-0
- idmap should mark as drifted if new uids/gids are added

* Wed Aug 16 2017 Ryan Barry <rbarry@redhat.com> - 0.9.44-0
- Use chroot again for setfiles

* Sat Aug 12 2017 Ryan Barry <rbarry@redhat.com> - 0.9.43-0
- Reconcile rebases in setfiles_t

* Wed Aug 09 2017 Ryan Barry <rbarry@redhat.com> - 0.9.42-0
- Set the NIST /tmp partition to 1GB
- Restore permissions on /usr/share for the rpmdb
- Make /etc remediation also sync systemd levels

* Tue Aug 08 2017 Ryan Barry <rbarry@redhat.com> - 0.9.41-0
- Remove the firstboot service
- Don't copy selinux policy files between layers
- Run RPM scripts with the correct pre/postinstall context

* Mon Aug 07 2017 Ryan Barry <rbarry@redhat.com> - 0.9.40-0
- Move selinux handling to a systemd service which runs after boot

* Fri Aug 04 2017 Ryan Barry <rbarry@redhat.com> - 0.9.39-0
- Add --xattrs-enable=* to untarring so suid bits get set
- Use the root redirection in setfiles instead of a chroot

* Wed Aug 02 2017 Ryan Barry <rbarry@redhat.com> - 0.9.38-0
- Run systemd-nspawn in a permissive domain

* Tue Aug 01 2017 Ryan Barry <rbarry@redhat.com> - 0.9.37-0
- Generate a clean uuid for systemd-nspawn

* Fri Jul 28 2017 Ryan Barry <rbarry@redhat.com> - 0.9.36-0
- Use lazy umounting so udev doesn't catch /etc during upgrades

* Thu Jul 27 2017 Ryan Barry <rbarry@redhat.com> - 0.9.35-0
- Ensure discard is also set for /
- Move initrd generation back to the main thread in osupdater

* Fri Jul 21 2017 Ryan Barry <rbarry@redhat.com> - 0.9.34-0
- Make sure NIST partitions have discard
- Only try to extend the metadata size if there is enough reserved space

* Tue Jun 27 2017 Ryan Barry <rbarry@redhat.com> - 0.9.33-0
- Always use a fixed locale for imgbased updates

* Thu Jun 22 2017 Ryan Barry <rbarry@redhat.com> - 0.9.32-0
- Work around lvm.conf changes in 7.4 when bind mounting /etc during updates

* Thu Jun 01 2017 Ryan Barry <rbarry@redhat.com> - 0.9.31-0
- Fix the arrangement of arguments to threaded_boot_runner

* Wed May 31 2017 Ryan Barry <rbarry@redhat.com> - 0.9.30-0
- Fix the arrangement of arguments to tar

* Wed May 31 2017 Ryan Barry <rbarry@redhat.com> - 0.9.29-0
- Remove references to setting LVM thinpool profile

* Thu May 25 2017 Ryan Barry <rbarry@redhat.com> - 0.9.28-0
- Delay imgbased-config-vdsm until after chronyd/ntpd
- Thread operations in osupdater to speed it up
- Re-add NIST migration and selinux commands
- Use tar instead of rsync for the initial filesystem sync

* Mon May 22 2017 Ryan Barry <rbarry@redhat.com> - 0.9.27-0
- Defer migrating to NIST again until the timeout is increased

* Tue May 16 2017 Ryan Barry <rbarry@redhat.com> - 0.9.26-0
- Disable running selinux commands in RPM %post scripts until engine
  timeout is increased

* Thu May 11 2017 Ryan Barry <rbarry@redhat.com> - 0.9.25-0
- Restore contexts on /usr/{bin,libexec,sbin} on updating

* Wed May 03 2017 Ryan Barry <rbarry@redhat.com> - 0.9.24-0
- Run selinux commands in RPM %post scripts on update

* Fri Apr 14 2017 Sandro Bonazzola <sbonazzo@redhat.com> - 0.9.23-0
- osupdater: using setfiles_t to relabel new fs

* Wed Apr 12 2017 Ryan Barry <rbarry@redhat.com> - 0.9.22-0
- Set selinux contexts on update

* Wed Apr 12 2017 Ryan Barry <rbarry@redhat.com> - 0.9.21-0
- Fix LVM volume filtering

* Fri Mar 31 2017 Ryan Barry <rbarry@redhat.com> - 0.9.20-0
- Make user/group addition work nicely during --init

* Thu Mar 30 2017 Ryan Barry <rbarry@redhat.com> - 0.9.19-0
- Migrate /var on updates
- Relabel /etc and /var on updates
- Add groups and users from new layers

* Tue Mar 14 2017 Ryan Barry <rbarry@redhat.com> - 0.9.18-0
- Don't copy critical files when remediating /etc

* Mon Mar 06 2017 Sandro Bonazzola <sbonazzo@redhat.com> - 0.9.16-0
- Added systemd unit for running vdsm-tool configure
- Resolves: BZ#1429288

* Fri Mar 03 2017 Ryan Barry <rbarry@redhat.com> - 0.9.15-0
- Add unmount to imgbased.utils

* Thu Feb 23 2017 Ryan Barry <rbarry@redhat.com> - 0.9.14-0
- Rescan all LVs on update

* Wed Feb 22 2017 Ryan Barry <rbarry@redhat.com> - 0.9.12-0
- Fix an error with imgbase --init

* Mon Feb 20 2017 Ryan Barry <rbarry@redhat.com> - 0.9.11-0
- Fix some logic problems in imgbased's handling of bases

* Mon Feb 20 2017 Douglas Schilling Landgraf <dougsland@redhat.com> - 0.9.10-0
- Keep unmodified configuration files
- Switch to a NIST partition layout on upgrades

* Thu Feb 02 2017 Douglas Schilling Landgraf <dougsland@redhat.com> - 0.9.7-0
- split the imgbase in two packages for python3 support

* Fri Jan 20 2017 Ryan Barry <rbarry@redhat.com> - 0.9.6-1
- Copy kernel FIPS signatures into /boot

* Wed Jan 18 2017 Ryan Barry <rbarry@redhat.com> - 0.9.5-1
- Revert selinux relabeling on upgrades

* Wed Jan 04 2017 Ryan Barry <rbarry@redhat.com> - 0.9.4-1
- Also keep depinstalled and depupdated for persistence

* Wed Jan 04 2017 Ryan Barry <rbarry@redhat.com> - 0.9.3-1
- Ensure new layers have enough space for hosted engine
- Copy the kernel and initrd to /boot so grub2-mkconfig and virt-v2v work

* Wed Jan 04 2017 Ryan Barry <rbarry@redhat.com> - 0.9.2-1
- Use GB instead of GiB in osupdater /boot validation

* Tue Jan 03 2017 Ryan Barry <rbarry@redhat.com> - 0.9.1-1
- Fix a typo in utils.SystemRelease which blocks installs

* Tue Dec 20 2016 Ryan Barry <rbarry@redhat.com> - 0.9.0-1
- Add a yum plugin to persist RPMs through upgrades
- Remove existing yum/dnf plugins

* Mon Nov 14 2016 Ryan Barry <rbarry@redhat.com> - 0.8.10-1
- Enable IQN randomization

* Fri Nov 11 2016 Ryan Barry <rbarry@redhat.com> - 0.8.9-1
- Also relocate on updates

* Thu Nov 10 2016 Ryan Barry <rbarry@redhat.com> - 0.8.8-1
- Relocate /var/lib/yum to /usr

* Fri Nov 4 2016 Ryan Barry <rbarry@redhat.com> - 0.8.7-1
- Fix a regression with the last patch in interactive installs

* Wed Oct 19 2016 Ryan Barry <rbarry@redhat.com> - 0.8.6-1
- Ensure disabled services stay disabled after upgrade

* Thu Sep 15 2016 Ryan Barry <rbarry@fedoraproject.org> - 0.8.5-1
- Remove non-imgbased entries at boot

* Wed Apr 02 2014 Fabian Deutsch <fabiand@fedoraproject.org> - 0.1-0.1
- Initial package
